<template>
  <div class="container">
    <template v-if="$fetchState.pending"> Loading ... </template>
    <template v-else-if="$fetchState.error">
      <AppError :error="$fetchState.error" />
    </template>
    <template v-else>
      <nuxt-link to="/" class="btn-ui back">
        <i class="icon-arrow-left" />
        Back
      </nuxt-link>
      <article class="c-country">
        <b-row class="justify-content-between align-items-center">
          <b-col lg="5">
            <b-aspect aspect="4:3" class="position-relative">
              <b-img-lazy
                v-bind="mainProps"
                :src="country.flag"
                :alt="country.name"
              />
            </b-aspect>
          </b-col>
          <b-col lg="6">
            <h1 class="c-country__title">{{ country.name }}</h1>
            <div class="c-country__details">
              <ul>
                <li>
                  <span class="details-title">Native Name:</span>
                  {{ country.nativeName }}
                </li>
                <li>
                  <span class="details-title">Population:</span>
                  {{ country.population.toLocaleString() }}
                </li>
                <li>
                  <span class="details-title">Region:</span>
                  {{ country.region }}
                </li>
                <li>
                  <span class="details-title">Sub Region:</span>
                  {{ country.subregion }}
                </li>
                <li>
                  <span class="details-title">Capital:</span>
                  {{ country.capital }}
                </li>
              </ul>
              <ul>
                <li>
                  <span class="details-title">Top Level Domain:</span>
                  <span
                    v-for="(domain, index) in country.topLevelDomain"
                    :key="index"
                  >
                    {{ domain }}
                    <span v-if="index != country.topLevelDomain.length - 1">
                      ,
                    </span>
                  </span>
                </li>
                <li>
                  <span class="details-title">Currencies:</span>
                  <span
                    v-for="(currency, index) in country.currencies"
                    :key="index"
                  >
                    {{ currency.name }}
                    <span v-if="index != country.currencies.length - 1"
                      >,
                    </span>
                  </span>
                </li>
                <li>
                  <span class="details-title">Languages:</span>
                  <span v-for="(lang, index) in country.languages" :key="index">
                    {{ lang.name }}
                    <span v-if="index != country.languages.length - 1">, </span>
                  </span>
                </li>
              </ul>
            </div>

            Borders Countries:
            <nuxt-link
              v-for="(border, index) in bordersCountries"
              :key="index"
              class="btn-ui"
              :to="`/country/${border.alpha3Code}`"
            >
              {{ border.name }}
            </nuxt-link>
          </b-col>
        </b-row>
      </article>
    </template>
  </div>
</template>

<script>
export default {
  async fetch() {
    if (!this.$store.state.countries.countriesList.length) {
      await this.$store.dispatch('countries/fetchCountriesList')
    }
    const data = await this.$axios
      .$get(`alpha/${encodeURI(this.$route.params.slug)}`)
      .catch((error) => {
        this.$sentry.captureException(
          new Error(error + ' country/' + encodeURI(this.$route.params.slug))
        )
        if (process.server) {
          this.$nuxt.context.res.statusCode = 404
        }
        throw new Error('Country Not Found !')
        // throw new Error(error)
      })
    this.country = data
  },
  data() {
    return {
      country: {},
      mainProps: {
        center: true,
        fluidGrow: true,
        blank: true,
        blankColor: '#bbb',
        class: 'ratio-img',
      },
    }
  },
  computed: {
    bordersCountries() {
      return this.$store.getters['countries/getBordersCountries'](
        this.country.borders
      )
    },
  },
  head() {
    return {
      title: this.country.name,
    }
  },
}
</script>

<style lang="scss" scoped>
.btn-ui {
  @include themed() {
    background: t('bg-secondary');
  }
  margin-right: 5px;
  margin-bottom: 10px;
  display: inline-block;
  padding: 5px 30px;
  border-radius: 5px;
  position: relative;
  top: 0px;
  box-shadow: 0 3px 1px -2px rgba(0, 0, 0, 0.2), 0 2px 2px 0 rgba(0, 0, 0, 0.14),
    0 1px 5px 0 rgba(0, 0, 0, 0.12);
  &:hover {
    top: -5px;
  }
}
.c-country {
  padding-bottom: 35px;
  .c-country__title {
    font-weight: 800;
    font-size: 25px;
  }
  .c-country__details {
    display: flex;
    padding-bottom: 85px;
    // flex: 0 0 100%;
    ul {
      flex-grow: 1;
      flex-basis: 0;
      li {
        line-height: 2.5rem;
        .details-title {
          font-weight: 600;
        }
      }
    }
  }
}

@media (max-width: 767px) {
  .back {
    margin-bottom: 35px;
  }
  .c-country {
    .c-country__title {
      padding-top: 35px;
    }
    .c-country__details {
      flex-direction: column;
      padding-bottom: 35px;
      ul:first-of-type {
        padding-bottom: 35px;
      }
    }
  }
}
</style>
